Skip to navigation

Create custom object records

View as Markdown

Creates custom object records with the given type.

Upon creating records of a custom object type, the 200 response contains a list of records that have been successfully processed and stored.

Limitations

This call has the following limitations:

  • The maximum number of records that you can create by one call is 1,000.
  • The storage of empty strings in records is not supported.
  • Null values must be formatted as the following example:
    {
    "records": [
    {
    "fieldName__c": null
    }
    ]
    }
  • When creating or updating custom object records with relationship-type fields, Zuora verifies the related objects against the transactional databases, which are updated in near real-time. The record creation or modification fails upon unsuccessful verifications.
    If the related objects are newly created in your tenant, it might need some time for the transactional database synchronization.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Path parameters

objectstringRequired

Specifies the custom object’s API name as object. It is case-sensitive.

Headers

Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersiondateOptional

API version that determines the response schema. The default version is used if this parameter is not included. Specify Zuora-Version in the request header if you expect a specific response schema.

Request

This endpoint expects an object.
recordslist of objectsRequired
A list of custom object records to be created
allowPartialSuccessbooleanOptionalDefaults to false
Indicates whether the records that pass the schema validation should be created when not all records in the request pass the schema validation.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.

Response

OK

The 200 response indicates that the records have been partially or completely created.

  • If the allowPartialSuccess flag is set to false, the 200 response indicates that all object records have been successfully created.
  • If the allowPartialSuccess flag is set to true, the 200 response indicates that some records might not be succesffully created and the error information might be contained in the response body.
errorobjectOptional
recordslist of objectsOptional
The custom object records that are succesfully created and stored

Errors

400
Bad Request Error
401
Unauthorized Error
500
Internal Server Error